import { Component, HTMLProps, MouseEvent } from "react";
import { FormData, Schema } from "../models";
export interface FormPropsChanges extends HTMLProps<HTMLFormElement> {
    data?: any;
    ref?: any;
}
export interface FormProps extends FormPropsChanges {
    hideCategoryField?: boolean;
    categoryFieldDisabled?: boolean;
    data?: FormData;
    loadingStateActiveOnSubmitButton?: boolean;
    noBackButton?: boolean;
    noJsonDebugger?: boolean;
    noSubmitButton?: boolean;
    schema?: Schema;
    submitButtonDisabled?: boolean;
    onChangeDebugObject?: (object: any) => void;
    onChangeFormData?: (formData: FormData) => void;
    onClickAddImagesButton?: () => void;
    onClickRemoveImageButton?: (image: any) => void;
    onClickBackButton?: (e: MouseEvent<HTMLButtonElement>) => void;
    onClickRemoveButton?: (e: MouseEvent<HTMLButtonElement>) => void;
    onClickOpenMap?: () => void;
    onSubmit?: (formData: FormData) => void;
}
export declare class Form extends Component<FormProps, {}> {
    static defaultProps: Partial<FormProps>;
    render(): JSX.Element;
    private renderFields;
    private tryRenderCategoriesSection;
    private handleSubmit;
    private handleChange;
    private tryIncludeAdditionalPropsInProperty;
}
