var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { Component } from 'react';
import ReactSelect from 'react-select';
import { TextField } from '@material-ui/core';
import withStyles from '@material-ui/core/styles/withStyles';
import * as classNames from 'classnames';
import equal from 'fast-deep-equal';
import { isViewport } from '../../utils/element';
const styles = (theme) => ({
    input: {
        display: 'flex',
        padding: 0,
    },
    control: {
        height: 56,
    },
});
const selectOptionStyles = (styles, { isDisabled, isFocused, isSelected }) => {
    return Object.assign({}, styles, { backgroundColor: getBackgroundColor(isDisabled, isFocused, isSelected), ':active': {
            backgroundColor: '#e1bee7',
        }, color: isDisabled ? '#ccc' : 'inherit', cursor: isDisabled ? 'not-allowed' : 'default' });
};
const selectValueRemoveStyles = (styles, { data }) => {
    return Object.assign({}, styles, { color: data.color, ':hover': {
            backgroundColor: '#d0d0d0',
            color: '#4a4a4a',
        } });
};
const getSelected = (isFocused, isSelected) => {
    const color = '#f2f2f2';
    const selectedColor = '#e2e2e2';
    return isSelected ? selectedColor : isFocused ? color : null;
};
const getBackgroundColor = (isDisabled, isFocused, isSelected) => isDisabled ? null : getSelected(isFocused, isSelected);
class CustomSelectComponent extends Component {
    constructor(props) {
        super(props);
        this.renderArrow = () => {
            return React.createElement("span", { className: "Select-arrow-zone" });
        };
        this.getValue = () => {
            const { value, options } = this.props;
            const foundValue = options.find((o) => o.value === value);
            return foundValue || null;
        };
        this.handleMenuPosition = () => {
            const { menuContainer } = this.reactSelect;
            if (menuContainer) {
                const isView = isViewport(menuContainer);
                if (!isView && !this.state.menuToUp) {
                    menuContainer.classList.add('up');
                    this.setState({ menuToUp: true });
                }
            }
        };
        this.onOpenHandler = () => {
            this.handleMenuPosition();
            const { onOpen } = this.props;
            if (onOpen) {
                onOpen();
            }
        };
        this.onCloseHandler = () => {
            this.setState({ menuToUp: false });
            const { onClose } = this.props;
            if (onClose) {
                onClose();
            }
        };
        this.state = {
            menuToUp: false,
        };
    }
    componentDidUpdate(prevProps, prevState) {
        if (!equal(this.props.value, prevProps.value)) {
            this.handleMenuPosition();
        }
    }
    render() {
        const _a = this.props, { onOpen, onClose, className, theme, value, options } = _a, otherProps = __rest(_a, ["onOpen", "onClose", "className", "theme", "value", "options"]);
        const { menuToUp } = this.state;
        return (React.createElement(ReactSelect, Object.assign({ ref: (ref) => (this.reactSelect = ref), components: components, arrowRenderer: this.renderArrow, className: classNames(className, { up: menuToUp }), onOpen: this.onOpenHandler, value: this.getValue(), onClose: this.onCloseHandler, styles: {
                option: selectOptionStyles,
                multiValueRemove: selectValueRemoveStyles,
            }, options: options, theme: (theme) => (Object.assign({}, theme, { colors: Object.assign({}, theme.colors, { primary: theme.palette ? theme.palette.primary.main : '#8007d4' }) })) }, otherProps)));
    }
}
export const CustomSelect = withStyles(styles, { withTheme: true })(CustomSelectComponent);
function inputComponent(_a) {
    var { inputRef } = _a, props = __rest(_a, ["inputRef"]);
    return React.createElement("div", Object.assign({ ref: inputRef }, props));
}
function Control(props) {
    return (React.createElement(TextField, Object.assign({ label: props.selectProps.label, fullWidth: true, variant: props.selectProps.variant || 'outlined', InputLabelProps: {
            shrink: true,
        }, InputProps: {
            inputComponent,
            inputProps: Object.assign({ className: `${props.selectProps.classes.input} ${props.selectProps.size === 'lg' ? props.selectProps.classes.control : ''} ${props.selectProps.customClass || ''}`, inputRef: props.innerRef, children: props.children }, props.innerProps),
        } }, props.selectProps.textFieldProps)));
}
const components = {
    Control,
};
