var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { MultiSelect, Select } from './../../FormWidget/Select';
export const SelectStrategy = (props) => {
    const { multiple } = props, otherProps = __rest(props, ["multiple"]);
    return multiple
        ? renderMultiSelect(otherProps)
        : renderSelect(otherProps);
};
SelectStrategy.displayName = 'SelectStrategy';
const renderMultiSelect = (props) => {
    const { options } = props;
    const value = props.value || [];
    const mappedValues = value
        .sort()
        .map(o => ({ text: o, value: o }));
    const mappedOptions = options
        .filter(o => value.length > 0 ? !value.includes(o) : true)
        .map(o => ({ text: o, value: o }));
    return (React.createElement(MultiSelect, Object.assign({}, props, { options: mappedOptions, size: "lg", value: mappedValues, onChange: handleMultiSelectChange(props.onChange) })));
};
const handleMultiSelectChange = (onChange) => (items) => {
    onChange(items.map(i => i.value));
};
const renderSelect = (props) => {
    const { options } = props, otherProps = __rest(props, ["options"]);
    const mappedOptions = options.map(o => ({ text: o, value: o }));
    return (React.createElement(Select, Object.assign({ options: mappedOptions, size: "lg" }, otherProps)));
};
