import _includes from 'lodash.includes';
import _isEmpty from 'lodash.isempty';
export const findClassificationsOfSelectedCategories = (selectedCategories = [], categoriesFromSchema) => {
    return categoriesFromSchema.reduce((classifications, category) => {
        const classificationAlreadyFound = !_isEmpty(classifications);
        if (classificationAlreadyFound) {
            return classifications;
        }
        const idsOfSelectedCategories = selectedCategories.map(c => c.id);
        const isCategorySelected = _includes(idsOfSelectedCategories, category._id);
        const hasClassifications = !_isEmpty(category.classifications);
        if (isCategorySelected && hasClassifications) {
            classifications.push(...category.classifications);
        }
        const hasChildren = !_isEmpty(category.children);
        if (hasChildren) {
            classifications.push(...findClassificationsOfSelectedCategories(selectedCategories, category.children));
        }
        return classifications;
    }, []);
};
