var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { PureComponent } from 'react';
import Checkbox from '@material-ui/core/Checkbox';
import Grid from '@material-ui/core/Grid';
import withStyles from '@material-ui/core/styles/withStyles';
import * as classNames from 'classnames';
import * as _omit from 'lodash.omit';
import { InputLabel } from '../InputText/InputLabel';
import { commonDefaultProps } from '../utils';
import { styles } from './InputCheck.style';
class Comp extends PureComponent {
    constructor() {
        super(...arguments);
        this.handleChange = (e) => {
            this.props.onChange(e.target.checked);
        };
    }
    render() {
        const _a = _omit(this.props, ['className', 'id']), { checked, helpText, label, name, onlyInput, text, required, value } = _a, otherProps = __rest(_a, ["checked", "helpText", "label", "name", "onlyInput", "text", "required", "value"]);
        const labelId = `label-for-${name}`;
        return onlyInput ? (this.renderInput()) : (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label" }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                this.renderInput(),
                helpText && React.createElement("div", { className: "form-control-feedback text-muted" }, helpText))));
    }
    renderInput() {
        const _a = _omit(this.props, [
            'className',
            'helpText',
            'id',
            'label',
            'onlyInput',
            'onChange',
        ]), { checked, disabled, text, labelStyle, classes } = _a, otherProps = __rest(_a, ["checked", "disabled", "text", "labelStyle", "classes"]);
        return (React.createElement("div", { className: classNames('form-check', classes.root) },
            React.createElement("label", { className: classNames('custom-checkbox', classes.label, { disabled }) },
                React.createElement(Checkbox, { className: "custom-checkbox-input custom-mui", checked: checked, disabled: disabled, onChange: this.handleChange, color: "primary" }),
                React.createElement("span", { className: "custom-control-description", style: labelStyle }, text))));
    }
}
Comp.defaultProps = Object.assign({}, commonDefaultProps, {
    onChange: () => null,
});
export const InputCheck = withStyles(styles)(Comp);
