var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { PureComponent } from 'react';
import Checkbox from '@material-ui/core/Checkbox';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import Grid from '@material-ui/core/Grid';
import withStyles from '@material-ui/core/styles/withStyles';
import * as classNames from 'classnames';
import * as _includes from 'lodash.includes';
import * as _omit from 'lodash.omit';
import { InputLabel } from '../InputText/InputLabel';
import { commonDefaultProps } from '../utils';
import { compose } from '../utils/funtional';
import { styles } from './InputCheckGroup.style';
let InputCheckGroup = class InputCheckGroup extends PureComponent {
    constructor() {
        super(...arguments);
        this.renderCheckInputs = () => {
            const _a = _omit(this.props, [
                'className',
                'columns',
                'helpText',
                'id',
                'isValid',
                'label',
                'options',
                'onlyInput',
            ]), { classes, name, value, labelTransform } = _a, otherProps = __rest(_a, ["classes", "name", "value", "labelTransform"]);
            return this.props.options.map((option) => (React.createElement("div", { key: option },
                React.createElement(FormControlLabel, Object.assign({ classes: {
                        root: classes.rootItem,
                        label: classes.label,
                    }, checked: _includes(value, option), name: name, label: labelTransform(option), value: option, onChange: this.handleChange(option), control: React.createElement(Checkbox, { color: "primary" }) }, otherProps)))));
        };
        this.handleChange = (option) => (e) => {
            const checked = e.target.checked;
            const oldValue = this.props.value;
            const newValue = checked
                ? [...oldValue, option]
                : oldValue.reduce((updatedValue, currentOption) => {
                    if (currentOption !== option) {
                        updatedValue.push(currentOption);
                    }
                    return updatedValue;
                }, []);
            this.props.onChange(newValue);
        };
    }
    render() {
        const { columns, helpText, label, name, classes } = _omit(this.props, [
            'className',
            'id',
        ]);
        const labelId = `label-for-${name}`;
        return (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: classNames('form-group', classes.root), spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label" }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                React.createElement("div", { className: classNames('form-check-group', classes.formCheckGroup), style: { columnCount: columns } }, this.renderCheckInputs()),
                helpText && React.createElement("div", { className: "form-control-feedback text-muted" }, helpText))));
    }
};
InputCheckGroup.defaultProps = Object.assign({}, commonDefaultProps, {
    columns: 1,
    options: [],
    value: [],
    onChange: () => null,
    labelTransform: (label) => label,
});
InputCheckGroup = __decorate([
    compose(withStyles(styles))
], InputCheckGroup);
export { InputCheckGroup };
