var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import * as dateformat from 'dateformat';
import _omit from 'lodash.omit';
import { PureComponent } from 'react';
import Grid from '@material-ui/core/Grid';
import { commonDefaultProps } from './utils';
import { Input } from './InputText/Input';
import { InputLabel } from './InputText/InputLabel';
export class InputDate extends PureComponent {
    constructor() {
        super(...arguments);
        this.handleChange = (e) => {
            this.props.onChange(Number(e.target.value));
        };
    }
    render() {
        const _a = _omit(this.props, [
            'className',
            'id',
            'onlyInput',
            'onChange',
        ]), { checked, helpText, label, name, required, value } = _a, otherProps = __rest(_a, ["checked", "helpText", "label", "name", "required", "value"]);
        const labelId = `label-for-${name}`;
        const inputValue = !!value && dateformat(value, 'yyyy-mm-dd');
        return (React.createElement(Grid, { "aria-labelledby": labelId, "aria-describedby": name, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                React.createElement(Input, Object.assign({ type: "date", name: name, value: inputValue, helperText: helpText, onChange: this.handleChange }, otherProps)))));
    }
}
InputDate.defaultProps = Object.assign({}, commonDefaultProps, {
    onChange: () => null,
});
