import * as React from "react";
import _omit from "lodash.omit";
import { PureComponent } from "react";
import { Button, Icon } from "bkn-ui";
import Grid from "@material-ui/core/Grid";
import { ThumbnailList } from "./ThumbnailList";
import { commonDefaultProps } from "./../utils";
import { InputLabel } from "../InputText/InputLabel";
const styles = {
    disabled: {
        thumbnailList: {
            marginTop: -8
        }
    }
};
export class InputFile extends PureComponent {
    constructor() {
        super(...arguments);
        this.handleChange = (e) => {
            this.props.onChange(Number(e.target.value));
        };
    }
    render() {
        const { checked, disabled, helpText, label, name, required, value, onClickAddImages, onClickRemoveImage, } = _omit(this.props, ["className", "id", "onChange"]);
        const labelId = `label-for-${name}`;
        const thumbnailListStyle = disabled ? styles.disabled.thumbnailList : {};
        return (React.createElement(Grid, { "aria-labelledby": labelId, className: "input-file", container: true, spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", id: labelId, required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                !disabled && (React.createElement(Button, { className: "cloudinary-uploader", color: "primary", size: "sm", onClick: onClickAddImages },
                    React.createElement(Icon, { name: "file_upload" }),
                    "Add image",
                    Array.isArray(value) ? "s" : "")),
                React.createElement(ThumbnailList, { images: value, noRemoveButton: disabled, style: thumbnailListStyle, onClickRemoveImageButton: onClickRemoveImage }),
                helpText && (React.createElement("div", { className: "form-control-feedback text-muted" }, helpText)))));
    }
}
InputFile.defaultProps = Object.assign({}, commonDefaultProps, {
    value: [],
    onChange: () => null,
    onClickAddImages: () => null,
    onClickRemoveImage: () => null
});
