import * as React from "react";
import { PureComponent } from "react";
import { GeometryPoint } from "./../../models";
import { CommonWidgetProps } from "./../utils";
export interface InputGeometryPointPropsChanges extends CommonWidgetProps<HTMLInputElement> {
    value?: any;
    onChange?: any;
}
export interface InputGeometryPointProps extends InputGeometryPointPropsChanges {
    value?: GeometryPoint;
    onChange?: (value: GeometryPoint) => void;
    onClickOpenMap?: () => void;
}
export interface InputGeometryState {
    latitude: string | number;
    longitude: string | number;
    latitudeFocused: boolean;
    longitudeFocused: boolean;
}
export declare class InputGeometryPoint extends PureComponent<InputGeometryPointProps, InputGeometryState> {
    static defaultProps: Partial<InputGeometryPointProps>;
    private updatedFromInside;
    constructor(props: InputGeometryPointProps);
    componentWillReceiveProps(nextProps: InputGeometryPointProps): void;
    componentDidUpdate(): void;
    render(): JSX.Element;
    getCoordinateValue(coordinateName: string, props: InputGeometryPointProps): any;
    handleChange: (field: string) => (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleFocus: (stateProp: string, focused: boolean) => () => void;
}
