var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import * as React from "react";
import { PureComponent } from "react";
import * as _omit from "lodash.omit";
import FormControl from "@material-ui/core/FormControl";
import FormControlLabel from "@material-ui/core/FormControlLabel";
import Radio from "@material-ui/core/Radio";
import RadioGroup from "@material-ui/core/RadioGroup";
import Grid from "@material-ui/core/Grid";
import withStyles from "@material-ui/core/styles/withStyles";
import { InputLabel } from "../InputText/InputLabel";
import { commonDefaultProps } from "../utils";
import { compose } from "../utils/funtional";
import { styles } from "./InputRadio.style";
let InputRadioGroup = class InputRadioGroup extends PureComponent {
    constructor() {
        super(...arguments);
        this.renderRadioInputs = (item) => {
            const { classes, labelTransform, name, value, onChange, disabled } = this.props;
            return (React.createElement(FormControlLabel, { classes: {
                    root: classes.root,
                    label: classes.label
                }, disabled: disabled, label: labelTransform(item), name: name, key: item, checked: value === item, value: item, onChange: this.handleChange, control: React.createElement(Radio, { color: "primary" }) }));
        };
        this.handleChange = (e) => {
            this.props.onChange(e.target.value);
        };
    }
    render() {
        const { columns, helpText, label, name, onlyInput, showResetButton, value, required, onClickResetButton, horizontal, classes } = _omit(this.props, ["className", "id"]);
        const labelId = `label-for-${name}`;
        return onlyInput ? (React.createElement("div", null,
            React.createElement(FormControl, { component: "fieldset", required: true },
                React.createElement(RadioGroup, { className: horizontal ? classes.row : "", "aria-label": label, name: name, value: value.toString(), onChange: this.handleChange }, this.props.options.map(o => this.renderRadioInputs(o)))))) : (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                React.createElement("div", { className: "form-check-group" },
                    React.createElement("div", { style: { columnCount: columns } }, this.props.options.map(o => (React.createElement("div", { key: o }, this.renderRadioInputs(o))))),
                    showResetButton && (React.createElement("a", { href: "javascript:void(0)", className: "d-inline-block text-uppercase", style: { marginTop: "1rem" }, onClick: onClickResetButton },
                        React.createElement("small", null, "Reset"))),
                    helpText && (React.createElement("div", { className: "form-control-feedback text-muted" }, helpText))))));
    }
};
InputRadioGroup.defaultProps = Object.assign({}, commonDefaultProps, {
    columns: 1,
    horizontal: false,
    labelTransform: (label) => label,
    options: [],
    showResetButton: false,
    onChange: () => null,
    onClickResetButton: () => null
});
InputRadioGroup = __decorate([
    compose(withStyles(styles))
], InputRadioGroup);
export { InputRadioGroup };
