var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from "react";
import * as classNames from "classnames";
import _omit from "lodash.omit";
import { PureComponent } from "react";
import { Input } from "./Input";
import { InputLabel } from "./InputLabel";
import { mapStringArrayToCommaSeparatedText } from "./../utils/array";
import { mapStringCommaSeparatedToArray } from "./../utils/string";
import Grid from "@material-ui/core/Grid";
import FormControl from "@material-ui/core/FormControl";
export class HorizontalFormFieldInput extends PureComponent {
    constructor(props) {
        super(props);
        this.getColor = (classes) => {
            const { isValid, success } = this.props;
            return classNames(classes, {
                danger: !isValid,
                success: isValid && success
            });
        };
        this.getValue = () => {
            let value = this.updatedFromInside ? this.state.text : this.props.value;
            if (Array.isArray(value)) {
                value = mapStringArrayToCommaSeparatedText(this.props.value);
            }
            return value;
        };
        this.handleChange = (e) => {
            const { value } = e.target;
            const { valueIsArray } = this.props;
            this.setState({
                text: e.target.value
            });
            this.updatedFromInside = true;
            const fieldValue = valueIsArray
                ? mapStringCommaSeparatedToArray(value)
                : value;
            this.props.onChange(fieldValue);
        };
        const value = Array.isArray(props.value)
            ? props.value
                .map(word => ` ${word}`)
                .join(",")
                .trim()
            : props.value;
        this.state = {
            text: value
        };
    }
    componentDidUpdate(prevProps) {
        this.updatedFromInside = false;
    }
    render() {
        const _a = _omit(this.props, [
            "className",
            "id",
            "onlyInput",
            "value",
            "onChange"
        ]), { isValid, helpText, label, name, required, success, successMessage, validationMessage, valueIsArray } = _a, otherProps = __rest(_a, ["isValid", "helpText", "label", "name", "required", "success", "successMessage", "validationMessage", "valueIsArray"]);
        const labelId = `label-for-${name}`;
        const value = this.getValue();
        return (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: this.getColor("form-group"), spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                React.createElement(FormControl, { fullWidth: true },
                    React.createElement(Input, Object.assign({ name: name, id: name, value: value, className: this.getColor(), helperText: helpText, onChange: this.handleChange }, otherProps)))),
            success && (React.createElement("div", { className: "form-control-feedback" }, successMessage)),
            !isValid && (React.createElement("div", { className: "form-control-feedback" }, validationMessage))));
    }
}
