var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { PureComponent } from 'react';
import FormHelperText from '@material-ui/core/FormHelperText';
import IconButton from '@material-ui/core/IconButton';
import MuiInput from '@material-ui/core/Input';
import InputAdornment from '@material-ui/core/InputAdornment';
import createStyles from '@material-ui/core/styles/createStyles';
import withStyles from '@material-ui/core/styles/withStyles';
import TextField from '@material-ui/core/TextField';
import Visibility from '@material-ui/icons/Visibility';
import VisibilityOff from '@material-ui/icons/VisibilityOff';
import { Icon } from 'bkn-ui';
import * as classNames from 'classnames';
const styles = () => createStyles({
    inputRoot: {
        padding: '17.5px 14px',
    },
    helperText: {
        fontSize: '14px',
        lineHeight: '1.5',
        marginLeft: 0,
    },
});
class InputComponent extends PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            revealPassword: false,
        };
        this.renderRevealPasswordButton = () => {
            const { revealPassword } = this.state;
            return (React.createElement("button", { className: classNames('reveal-password-btn', {
                    active: revealPassword,
                }), type: "button", onClick: this.toggleRevealPassword },
                React.createElement(Icon, { name: "remove_red_eye" })));
        };
        this.toggleRevealPassword = () => this.setState({ revealPassword: !this.state.revealPassword });
    }
    render() {
        const _a = this.props, { showRevealPasswordButton, type, classes, helperText } = _a, otherProps = __rest(_a, ["showRevealPasswordButton", "type", "classes", "helperText"]);
        const { revealPassword } = this.state;
        const modifiedType = revealPassword ? 'text' : type;
        const hasNoErrors = this.props.state !== 'danger';
        return (type === 'password' ? (React.createElement("div", { className: "reveal-password-container" },
            React.createElement(MuiInput, Object.assign({ variant: "outlined", inputProps: {
                    className: classes.inputRoot,
                }, type: modifiedType }, otherProps, { endAdornment: hasNoErrors && (React.createElement(InputAdornment, { position: "end" },
                    React.createElement(IconButton, { "aria-label": "Toggle password visibility", onClick: this.toggleRevealPassword }, this.state.revealPassword ? React.createElement(VisibilityOff, null) : React.createElement(Visibility, null)))) })),
            helperText && React.createElement(FormHelperText, null, helperText))) : (React.createElement(TextField, Object.assign({ inputProps: {
                className: classes.inputRoot,
            }, type: modifiedType, FormHelperTextProps: { classes: { root: classes.helperText } }, variant: "outlined" }, otherProps))));
    }
}
export const Input = withStyles(styles)(InputComponent);
