var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { VerticalFormFieldInput } from './VerticalFormFieldInput';
import { HorizontalFormFieldInput } from './HorizontalFormFieldInput';
import { commonDefaultProps } from './../utils';
export const InputText = (props) => {
    const { vertical } = props, otherProps = __rest(props, ["vertical"]);
    return renderFormFieldInput(props);
};
InputText.displayName = 'FormField.InputText';
InputText.defaultProps = Object.assign({}, commonDefaultProps, {
    success: false,
    isValid: true,
    successMessage: '',
    type: 'text',
    vertical: false,
});
const renderFormFieldInput = (props) => {
    const { vertical } = props, otherProps = __rest(props, ["vertical"]);
    if (vertical) {
        return React.createElement(VerticalFormFieldInput, Object.assign({}, otherProps));
    }
    else {
        return React.createElement(HorizontalFormFieldInput, Object.assign({}, otherProps));
    }
};
