var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from "react";
import * as classNames from "classnames";
import _omit from "lodash.omit";
import { PureComponent } from "react";
import FormGroup from "@material-ui/core/FormGroup";
import { Input } from "./Input";
import { InputLabel } from "./InputLabel";
export class VerticalFormFieldInput extends PureComponent {
    constructor() {
        super(...arguments);
        this.getColor = () => {
            const { isValid, success } = this.props;
            return classNames({
                danger: !isValid,
                success: isValid && success
            });
        };
    }
    render() {
        const _a = _omit(this.props, ["onlyInput"]), { className, helpText, id, isValid, label, name, success, successMessage, required, validationMessage, value } = _a, otherProps = __rest(_a, ["className", "helpText", "id", "isValid", "label", "name", "success", "successMessage", "required", "validationMessage", "value"]);
        const labelId = `label-for-${name}`;
        return (React.createElement(FormGroup, { "aria-labelledby": labelId, "aria-describedby": name, className: "form-group" },
            React.createElement(InputLabel, { className: "col-form-label", required: required }, label),
            React.createElement(Input, Object.assign({ name: name, id: name, value: value, state: this.getColor() }, otherProps)),
            success && (React.createElement("div", { className: "form-control-feedback" }, successMessage)),
            !isValid && (React.createElement("div", { className: "form-control-feedback" }, validationMessage)),
            helpText && (React.createElement("div", { className: "form-control-feedback text-muted" }, helpText))));
    }
}
