var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { PureComponent } from 'react';
import { Scrollbars } from 'react-custom-scrollbars';
import Grid from '@material-ui/core/Grid';
import IconButton from '@material-ui/core/IconButton';
import withStyles from '@material-ui/core/styles/withStyles';
import ClearIcon from '@material-ui/icons/Clear';
import * as _isEmpty from 'lodash.isempty';
import * as _omit from 'lodash.omit';
import * as _without from 'lodash.without';
import { CustomSelect } from '../../../Form/utils/CustomSelect';
import { InputLabel } from '../../InputText/InputLabel';
import { commonDefaultProps } from '../../utils';
import { styles } from './styles';
class MultiSelect extends PureComponent {
    constructor(props) {
        super(props);
        this.renderInput = () => {
            const _a = _omit(this.props, ['className', 'id']), { helpText, name, placeholder, scrollHeight, value, className, classes, onlyInput, label } = _a, otherProps = __rest(_a, ["helpText", "name", "placeholder", "scrollHeight", "value", "className", "classes", "onlyInput", "label"]);
            return (React.createElement("div", { className: classes.root },
                !_isEmpty(value) && (React.createElement(Scrollbars, { ref: (scrl) => {
                        this.scrollBars = scrl;
                    }, autoHeight: true, autoHeightMax: scrollHeight },
                    React.createElement("ul", { className: classes.selectedItems }, value.map((v, index) => {
                        const { showRemoveButtonOnlyForLastSelectedValue } = this.props;
                        const isLastSelectedValue = value.length - 1 === index;
                        const showRemoveIcon = showRemoveButtonOnlyForLastSelectedValue
                            ? isLastSelectedValue
                            : true;
                        return (React.createElement("li", { key: v.value, className: classes.selectedItem },
                            React.createElement("span", { className: classes.selectedItemTitle }, v.text),
                            showRemoveIcon && (React.createElement(IconButton, { color: "primary", style: { width: 20, height: 20, padding: '2px' }, onClick: this.handleRemove(v) },
                                React.createElement(ClearIcon, { style: { fontSize: 17 } })))));
                    })))),
                React.createElement(CustomSelect, Object.assign({}, otherProps, { label: onlyInput ? label : '', className: classes.customSelectRoot, clearable: false, name: name, placeholder: placeholder || '', options: this.getOptions(), value: "", onChange: this.handleChange, onOpen: this.handleOpenMenu, isMulti: false })),
                helpText && React.createElement("div", { className: "form-control-feedback text-muted" }, helpText)));
        };
        this.handleChange = (selectedValue) => {
            if (!_isEmpty(selectedValue)) {
                this.setState({ added: true });
                this.props.onChange([...this.props.value, selectedValue]);
            }
        };
        this.handleRemove = (value) => () => {
            this.setState({ added: false });
            this.props.onChange(_without([...this.props.value], value));
        };
        this.handleOpenMenu = () => {
            setTimeout(() => document.querySelectorAll('.Select-menu').forEach((el) => (el.scrollTop = 0)), 0);
        };
        this.getOptions = () => {
            return this.props.options.map((o) => ({ label: o.text, value: o.value }));
        };
        this.state = {
            added: false,
        };
    }
    componentDidUpdate(prevProps) {
        if (this.props.value !== prevProps.value) {
            if (this.state.added && this.scrollBars) {
                this.scrollBars.scrollToBottom();
            }
        }
    }
    render() {
        const { label, name, onlyInput, required } = _omit(this.props, [
            'className',
            'id',
        ]);
        const labelId = `label-for-${name}`;
        return onlyInput ? (this.renderInput()) : (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 }, this.renderInput())));
    }
}
MultiSelect.defaultProps = Object.assign({}, commonDefaultProps, {
    options: [],
    removeButtonOnRightSide: false,
    autosize: false,
    scrollHeight: 100,
    showRemoveButtonOnlyForLastSelectedValue: false,
    size: '',
    value: [],
    onChange: () => null,
});
export default withStyles(styles)(MultiSelect);
