import * as React from 'react';
import { PureComponent } from 'react';
import { Option } from '../../models';
import { CommonWidgetProps } from '../utils';
export interface SelectChangeProps extends CommonWidgetProps<HTMLInputElement> {
    searchable?: any;
    size?: any;
    value?: any;
    onChange?: any;
}
export interface SelectProps extends SelectChangeProps {
    nativeSelect?: boolean;
    options?: Option[];
    clearable?: boolean;
    searchable?: boolean;
    size?: 'lg' | '';
    value?: string | number;
    autosize?: boolean;
    onChange?: (value?: string | number) => void;
    renderOption?: (option: Option) => JSX.Element;
}
export declare class Select extends PureComponent<SelectProps, {}> {
    static defaultProps: Partial<SelectProps>;
    render(): JSX.Element;
    renderInput: () => JSX.Element;
    renderOptions: () => JSX.Element[];
    handleOpenMenu: () => void;
    getOptions: () => {
        value: string;
        disabled?: boolean;
        label: string;
        selected?: boolean;
        defaultChecked?: boolean;
        defaultValue?: string | string[];
        suppressContentEditableWarning?: boolean;
        accessKey?: string;
        className?: string;
        contentEditable?: boolean;
        contextMenu?: string;
        dir?: string;
        draggable?: boolean;
        hidden?: boolean;
        id?: string;
        lang?: string;
        slot?: string;
        spellCheck?: boolean;
        style?: React.CSSProperties;
        tabIndex?: number;
        title?: string;
        inputMode?: string;
        is?: string;
        radioGroup?: string;
        role?: string;
        about?: string;
        datatype?: string;
        inlist?: any;
        prefix?: string;
        property?: string;
        resource?: string;
        typeof?: string;
        vocab?: string;
        autoCapitalize?: string;
        autoCorrect?: string;
        autoSave?: string;
        color?: string;
        itemProp?: string;
        itemScope?: boolean;
        itemType?: string;
        itemID?: string;
        itemRef?: string;
        results?: number;
        security?: string;
        unselectable?: boolean;
        children?: React.ReactNode;
        dangerouslySetInnerHTML?: {
            __html: string;
        };
        onCopy?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onCopyCapture?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onCut?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onCutCapture?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onPaste?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onPasteCapture?: (event: React.ClipboardEvent<HTMLOptionElement>) => void;
        onCompositionEnd?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onCompositionEndCapture?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onCompositionStart?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onCompositionStartCapture?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onCompositionUpdate?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onCompositionUpdateCapture?: (event: React.CompositionEvent<HTMLOptionElement>) => void;
        onFocus?: (event: React.FocusEvent<HTMLOptionElement>) => void;
        onFocusCapture?: (event: React.FocusEvent<HTMLOptionElement>) => void;
        onBlur?: (event: React.FocusEvent<HTMLOptionElement>) => void;
        onBlurCapture?: (event: React.FocusEvent<HTMLOptionElement>) => void;
        onChange?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onChangeCapture?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onInput?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onInputCapture?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onReset?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onResetCapture?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onSubmit?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onSubmitCapture?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onInvalid?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onInvalidCapture?: (event: React.FormEvent<HTMLOptionElement>) => void;
        onLoad?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onError?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onErrorCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onKeyDown?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onKeyDownCapture?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onKeyPress?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onKeyPressCapture?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onKeyUp?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onKeyUpCapture?: (event: React.KeyboardEvent<HTMLOptionElement>) => void;
        onAbort?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onAbortCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onCanPlay?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onCanPlayCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onCanPlayThrough?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onCanPlayThroughCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onDurationChange?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onDurationChangeCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEmptied?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEmptiedCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEncrypted?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEncryptedCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEnded?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onEndedCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadedData?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadedDataCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadedMetadata?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadedMetadataCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadStart?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onLoadStartCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPause?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPauseCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPlay?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPlayCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPlaying?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onPlayingCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onProgress?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onProgressCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onRateChange?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onRateChangeCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSeeked?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSeekedCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSeeking?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSeekingCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onStalled?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onStalledCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSuspend?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSuspendCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onTimeUpdate?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onTimeUpdateCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onVolumeChange?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onVolumeChangeCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onWaiting?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onWaitingCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onClick?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onClickCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onContextMenu?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onContextMenuCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onDoubleClick?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onDoubleClickCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onDrag?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragEnd?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragEndCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragEnter?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragEnterCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragExit?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragExitCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragLeave?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragLeaveCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragOver?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragOverCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragStart?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDragStartCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDrop?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onDropCapture?: (event: React.DragEvent<HTMLOptionElement>) => void;
        onMouseDown?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseDownCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseEnter?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseLeave?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseMove?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseMoveCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseOut?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseOutCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseOver?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseOverCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseUp?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onMouseUpCapture?: (event: React.MouseEvent<HTMLOptionElement>) => void;
        onSelect?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onSelectCapture?: (event: React.SyntheticEvent<HTMLOptionElement>) => void;
        onTouchCancel?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchCancelCapture?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchEnd?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchEndCapture?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchMove?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchMoveCapture?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchStart?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onTouchStartCapture?: (event: React.TouchEvent<HTMLOptionElement>) => void;
        onScroll?: (event: React.UIEvent<HTMLOptionElement>) => void;
        onScrollCapture?: (event: React.UIEvent<HTMLOptionElement>) => void;
        onWheel?: (event: React.WheelEvent<HTMLOptionElement>) => void;
        onWheelCapture?: (event: React.WheelEvent<HTMLOptionElement>) => void;
        onAnimationStart?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onAnimationStartCapture?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onAnimationEnd?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onAnimationEndCapture?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onAnimationIteration?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onAnimationIterationCapture?: (event: React.AnimationEvent<HTMLOptionElement>) => void;
        onTransitionEnd?: (event: React.TransitionEvent<HTMLOptionElement>) => void;
        onTransitionEndCapture?: (event: React.TransitionEvent<HTMLOptionElement>) => void;
    }[];
    handleNativeSelectChange: (e: React.ChangeEvent<HTMLSelectElement>) => void;
    handleReactSelectChange: (option: {
        label: string;
        value: string;
    }) => void;
}
