var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { PureComponent } from 'react';
import Grid from '@material-ui/core/Grid';
import * as classNames from 'classnames';
import * as _omit from 'lodash.omit';
import { CustomSelect } from '../../Form/utils/CustomSelect';
import { InputLabel } from '../InputText/InputLabel';
import { commonDefaultProps } from '../utils';
export class Select extends PureComponent {
    constructor() {
        super(...arguments);
        this.renderInput = () => {
            const _a = _omit(this.props, [
                'className',
                'helpText',
                'isValid',
                'options',
                'onChange',
            ]), { clearable, disabled, nativeSelect, onlyInput, placeholder, renderOption, label } = _a, otherProps = __rest(_a, ["clearable", "disabled", "nativeSelect", "onlyInput", "placeholder", "renderOption", "label"]);
            return nativeSelect ? (React.createElement("select", Object.assign({ className: classNames('form-control custom-select', {
                    'form-control-lg': !onlyInput,
                }), onChange: this.handleNativeSelectChange }, otherProps),
                React.createElement("option", null, placeholder || ''),
                this.renderOptions())) : (React.createElement(CustomSelect, Object.assign({}, otherProps, { label: onlyInput ? label : '', isClearable: clearable, isDisabled: disabled, placeholder: placeholder || '', openOnFocus: true, optionRenderer: renderOption, options: this.getOptions(), onChange: this.handleReactSelectChange, onOpen: this.handleOpenMenu })));
        };
        this.renderOptions = () => {
            return this.props.options.map((o) => (React.createElement("option", Object.assign({ key: o.value }, o), o.text || o.value)));
        };
        this.handleOpenMenu = () => {
            setTimeout(() => document.querySelectorAll('.Select-menu').forEach((el) => (el.scrollTop = 0)), 0);
        };
        this.getOptions = () => {
            return this.props.options.map((o) => {
                const { text } = o, otherProps = __rest(o, ["text"]);
                return Object.assign({ label: text }, otherProps);
            });
        };
        this.handleNativeSelectChange = (e) => {
            this.props.onChange(e.target.value);
        };
        this.handleReactSelectChange = (option) => {
            if (option) {
                this.props.onChange(option.value);
            }
            else if (this.props.clearable) {
                this.props.onChange();
            }
        };
    }
    render() {
        const { label, name, onlyInput, required } = _omit(this.props, ['id', 'options']);
        const labelId = `label-for-${name}`;
        return onlyInput ? (this.renderInput()) : (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label", required: required }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 }, this.renderInput())));
    }
}
Select.defaultProps = Object.assign({}, commonDefaultProps, {
    nativeSelect: false,
    clearable: false,
    options: [],
    searchable: false,
    autosize: false,
    size: '',
    value: '',
    onChange: () => null,
});
